## simbamond 4.1

=== Makefile ===
# Makefile for simbamon
# This code is copyright Hamish Cunningham and the University of Sheffield
# and is licenced under GPL 3 or any later version.

# vars #######################################################################
VERSION=4.1
NEXT_SNAP=1
P=simbamond
D=simbamon
MOPI=mopi
MOPICLI=mopicli
MOPIAPI=mopiapi.py
PD=package/$(VERSION)
INSTALLED_FILES=\
  $(DESTDIR)/usr/sbin/$(D) \
  $(DESTDIR)/usr/sbin/$(MOPI) \
  $(DESTDIR)/usr/sbin/$(MOPICLI) \
  $(DESTDIR)/usr/sbin/$(MOPIAPI) \
  $(DESTDIR)/etc/init.d/$(P) \
  $(DESTDIR)/etc/default/$(P) \
  $(DESTDIR)/usr/share/man/man8/$(D).8.gz \
  $(DESTDIR)/usr/share/man/man8/$(P).8.gz \
  $(DESTDIR)/usr/share/man/man8/$(MOPI).8.gz \
  $(DESTDIR)/usr/share/man/man8/$(MOPICLI).8.gz \
  $(DESTDIR)/usr/share/man/man8/$(MOPIAPI).8.gz
INIT_LINKS=\
  $(DESTDIR)/etc/rc?.d/*$(P)
PACKAGE_FILES=\
  $(P)_$(VERSION)*.deb \
  $(P)_$(VERSION)*.dsc \
  $(P)_$(VERSION)*.tar.xz \
  $(P)_$(VERSION)*.changes \
  $(P)_$(VERSION)*.build
NOW:=$(shell date "+%Y-%m-%d-%R" |sed 's,:,,')
MAJOR_VERSION:=$(shell echo $(VERSION) |sed 's,\([0-9]*\)\..*,\1,')
MINOR_VERSION:=$(shell echo $(VERSION) |sed 's,.*\.,,')
SNAPSHOT_VERSION:=$(VERSION)+$(NEXT_SNAP)
SNAPSHOT:=$(SNAPSHOT_VERSION)-SNAPSHOT-$(NOW)
SNAPD:=$(PD)/snapshots/$(SNAPSHOT)

# functions ##################################################################
do-listing=\
  ls $(INSTALLED_FILES) `[ -z "$(DESTDIR)" ] && echo $(INIT_LINKS)` || :

# help #######################################################################
help:
	@echo 'Makefile for simbamon                                         '
	@echo '                                                              '
	@echo 'Usage:                                                        '
	@echo '   make install                   installs the simbamon daemon'
	@echo '   make uninstall                 removes the daemon          '
	@echo '   make list                      list installed files        '
	@echo '   make package                   create .deb/.dcs packagings '
	@echo '   make package-upload            upload to PPA repository    '
	@echo '   make package-clean             delete tmp packaging files  '
	@echo '   make package-info              apt-cache showpkg           '
	@echo '   make package-purge             apt-get purge               '
	@echo '   make package-version           update the changelog        '
	@echo '   make print-versions            print current version #s    '
	@echo '                                                              '

# show versions ##############################################################
print-versions:
	@echo "VERSION: $(VERSION); SNAPSHOT_VERSION: $(SNAPSHOT_VERSION)"

# install ####################################################################
# (if DESTDIR is set we assume this is a packaging run, not an install, and so
# don't run update-rc.d)
install:
	install -d -m 755           $(DESTDIR)/usr/sbin
	install -d -m 755           $(DESTDIR)/etc/init.d
	install -d -m 755           $(DESTDIR)/etc/default
	install -d -m 755           $(DESTDIR)/usr/share/man/man8
	install $(P).default        $(DESTDIR)/etc/default/$(P)
	install -m 755 $(D)         $(DESTDIR)/usr/sbin
	install -m 755 $(P).init    $(DESTDIR)/etc/init.d/$(P)
	install -m 755 $(MOPI)      $(DESTDIR)/usr/sbin
	install -m 755 $(MOPICLI)   $(DESTDIR)/usr/sbin
	install -m 644 $(MOPIAPI)   $(DESTDIR)/usr/sbin
	install man/$(P).8.gz       $(DESTDIR)/usr/share/man/man8
	install man/$(D).8.gz       $(DESTDIR)/usr/share/man/man8
	install man/$(MOPI).8.gz    $(DESTDIR)/usr/share/man/man8
	install man/$(MOPICLI).8.gz $(DESTDIR)/usr/share/man/man8
	install man/$(MOPIAPI).8.gz $(DESTDIR)/usr/share/man/man8
	[ -z "$(DESTDIR)" ] && update-rc.d $(P) defaults || :
	@echo 'simbamon installed: '
	@$(do-listing)

# uninstall ##################################################################
uninstall:
	@echo 'removing simbamon files: '
	@$(do-listing)
	[ -z "$(DESTDIR)" ] && update-rc.d -f $(P) remove || :
	sudo rm -f $(INSTALLED_FILES)
	@echo done

# manpage ####################################################################
man: man/$(P).txt man/$(MOPI).txt man/$(MOPICLI).txt
	cd man; ../utils/txt2man -v "System Manager's Manual" -s 8 \
          -t '$(D)' $(P).txt >$(P).8; \
	sed -i 1d $(P).8;  # fix error from lintian about ." macro \
	cat $(P).8 |gzip >$(P).8.gz; cp $(P).8.gz $(D).8.gz
	cd man; ../utils/txt2man -v "System Manager's Manual" -s 8 \
          -t '$(MOPI)' $(MOPI).txt >$(MOPI).8; \
	sed -i 1d $(MOPI).8;  # fix error from lintian about ." macro \
	cat $(MOPI).8 |gzip >$(MOPI).8.gz;
	cd man; ../utils/txt2man -v "System Manager's Manual" -s 8 \
          -t '$(MOPICLI)' $(MOPICLI).txt >$(MOPICLI).8; \
	sed -i 1d $(MOPICLI).8;  # fix error from lintian about ." macro \
	cat $(MOPICLI).8 |gzip >$(MOPICLI).8.gz; \
	cp $(MOPICLI).8.gz $(MOPIAPI).8.gz

# package ####################################################################
version:
	@for f in simbamond.default mopicli mopiapi.py; do \
          sed -i 's,^VERSION=.*,VERSION=\"'$(VERSION)'\",' $$f; done
package: version man package-unstable package-precise
	@echo "\nunstable:"
	@ls -lh $(PD)/unstable
	@echo "\nprecise:"
	@ls -lh $(PD)/precise
package-unstable:
	@echo 'packaging simbamon for Debian unstable...'
	mkdir -p $(PD)/unstable
	rm -f $(PD)/unstable/*
	sed -i \
          's,\(^$(P) ('$(VERSION)') \)[a-z]*,\1unstable,' debian/changelog
	debuild -Ipackage
	@echo ""
	cd .. && for f in $(PACKAGE_FILES); do \
          [ -f $$f ] && mv $$f $(D)/$(PD)/unstable || :; done
package-precise:
	@echo 'packaging simbamon for Ubuntu precise...'
	mkdir -p $(PD)/precise
	rm -f $(PD)/precise/*
	sed -i 's,\(^$(P) ('$(VERSION)') \)[a-z]*,\1precise,' debian/changelog
	debuild -S -Ipackage
	sed -i 's,\(^$(P) ('$(VERSION)') \)[a-z]*,\1unstable,' \
          debian/changelog
	@echo ""
	cd .. && for f in $(PACKAGE_FILES); do \
          [ -f $$f ] && mv $$f $(D)/$(PD)/precise || :; done
snapshot-version:
	@for f in simbamond.default mopicli mopiapi.py; do \
          sed -i 's,^VERSION=.*,VERSION=\"'$(SNAPSHOT_VERSION)'\",' $$f; done
	sed -i 's,^NEXT_SNAP=.*,NEXT_SNAP='$$(($(NEXT_SNAP) + 1))',' Makefile
snapshot: snapshot-version
	@echo "packaging simbamon SNAPSHOT $(SNAPSHOT)..."
	mkdir -p $(SNAPD)
	rm -rf $(SNAPD)/*
	sed -i -e 's,\(^$(P) ('$(VERSION)') \)[a-z]*,\1precise,' \
	       -e 's,^$(P) ($(VERSION),$(P) ($(SNAPSHOT_VERSION),' \
          debian/changelog
	@head -1 debian/changelog
	debuild -S -Ipackage
	sed -i -e 's,^$(P) ($(SNAPSHOT_VERSION),$(P) ($(VERSION),' \
               -e 's,\(^$(P) ('$(VERSION)') \)[a-z]*,\1unstable,' \
          debian/changelog
	@head -1 debian/changelog
	@echo ""
	cd .. && for f in $(PACKAGE_FILES); do \
          [ -f $$f ] && mv $$f $(D)/$(SNAPD) || :; done
	@echo "\nsnapshot:"
	@ls -lhR $(SNAPD)

# package-upload #############################################################
package-upload:
	cd $(PD)/precise && dput ppa:hamish-dcs/pi-gate \
          $(P)_$(VERSION)_source.changes
	cd $(PD)/precise && mv $(P)_$(VERSION)*.ppa.upload /tmp || :

# snapshot-upload ############################################################
# relies on lexical ordering of snapshot names to pick the latest one
# (apt also relies on this ordering)
snapshot-upload:
	cd package/$(VERSION)/snapshots; \
	LAST_SNAP=`ls -r |head -1`; \
        cd $$LAST_SNAP && \
          dput ppa:hamish-dcs/pi-gate-snapshots $(P)*_source.changes; \
	mv $(P)_*.ppa.upload /tmp || :

# package utilities
package-info:
	apt-cache showpkg $(P)
package-purge:
	apt-get purge $(P)
package-clean:
	dh_clean
package-version:
	dch -i
	@echo 'remember to change VERSION in the Makefile!'

# test #######################################################################
#test:
#	echo; sudo python ./api-test.py |pr -l 33 -t -2 -w 132; echo

# list #######################################################################
list:
	@$(do-listing)

# phonies ####################################################################
.PHONY: install uninstall package package-unstable package-precise
.PHONY: package-upload package-clean list version snapshot-version

=== debian/changelog ===
simbamond (4.1) unstable; urgency=low

  * Fix i2c under device tree (issue 36); Firmware 3.10, API 0.3, CLI 0.5

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 17 Feb 2015 16:09:35 +0000

simbamond (4.0) unstable; urgency=low

  * First KickStarter shipment release, for Firmware 3.10, API 0.3, CLI 0.5

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Wed, 25 Jun 2014 19:03:12 +0100

simbamond (3.6) unstable; urgency=low

  * Final test release prior to 4.0

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Wed, 25 Jun 2014 08:51:38 +0100

simbamond (3.5) unstable; urgency=low

  * Version 3.5, 3rd-party test release, for firmware version 3.08

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Fri, 30 May 2014 22:11:06 +0100

simbamond (3.4) unstable; urgency=low

  * Snapshots 3.4+1...

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Fri, 30 May 2014 11:03:59 +0100

simbamond (3.3) unstable; urgency=low

  * Snapshot releases in the 3.3+1 series

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 27 May 2014 10:06:36 +0100

simbamond (3.2+9) unstable; urgency=low

  *  Snapshot releases in the 3.2+1 series

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 20 May 2014 11:57:52 +0200

simbamond (3.1) unstable; urgency=low

  * Snapshot releases in the 3.1+1 series

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 06 May 2014 21:27:02 +0100

simbamond (3.0) unstable; urgency=low

  * Snapshot releases in the 3.0+1 series

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Mon, 14 Apr 2014 11:08:22 +0100

simbamond (2.0) unstable; urgency=low

  * Version 2.0 matches the 2nd series of MoPi prototype boards. (Note new physical pin mappings.)

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Wed, 13 Nov 2013 12:26:53 +0000

simbamond (1.3) unstable; urgency=low

  * Snapshot releases in the 1.3+4 series.

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 17 Sep 2013 13:44:00 +0100

simbamond (1.2) unstable; urgency=low

  * Snapshot releases in the 1.2+3 series.

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Mon, 26 Aug 2013 14:49:57 +0300

simbamond (1.1) unstable; urgency=low

  * Snapshot releases in the 1.1+2 series.

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Tue, 20 Aug 2013 16:40:03 +0300

simbamond (1.0) unstable; urgency=low

  * Initial Release.

 -- Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>  Wed, 14 Aug 2013 10:25:02 +0300

=== debian/control ===
Source: simbamond
Section: admin
Priority: optional
Maintainer: Hamish Cunningham (http://gate.ac.uk/hamish/) <hamish@gate.ac.uk>
Build-Depends: debhelper (>= 8.0.0), devscripts, gawk
Standards-Version: 3.9.3
Homepage: http://pi.gate.ac.uk/pages/mopi.html#simbamon
Vcs-Git: git://github.com/hamishcunningham/pi-tronics.git
Vcs-Browser: https://github.com/hamishcunningham/pi-tronics/tree/master/simbamon

Package: simbamond
Architecture: all
Depends: python-rpi.gpio, python-smbus, whiptail, bc, ${misc:Depends}
Recommends:
Description: simbamon, a Simple Battery Monitor
 simbamon is an open source Linux daemon for monitoring battery levels;
 sending warning messages to the user if the battery is low; shutting down
 cleanly at critical battery levels; managing a power supply on/off switch;
 writing relevant data to the system logs. It is bundled with configuration
 and API tools for the MoPi mobile Pi power board. See
 http://pi.gate.ac.uk/pages/mopi.html#simbamon

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh $@
